package org.ow2.bonita.facade.ejb;

import java.util.logging.Level;
import java.util.logging.Logger;

import org.ow2.novabpm.util.Misc;


public final class EJB2SecurityOwner {

  private static final InheritableThreadLocal<String> USERS = new InheritableThreadLocal<String>();
  private static final Logger LOG = Logger.getLogger(EJB2SecurityOwner.class.getName());
  
  private EJB2SecurityOwner() { }
  
  public static String getUser() {
    if (LOG.isLoggable(Level.FINEST)) {
      LOG.entering(EJB2SecurityOwner.class.getName(), "getUser");
    }
    final String userId = USERS.get();
    Misc.badStateIfNull(userId, "No user found. Are you sure you are loged in EJB2 context ?");

    if (LOG.isLoggable(Level.FINEST)) {
      LOG.exiting(EJB2SecurityOwner.class.getName(), "getUser", userId);
    }
    return userId;
  }
  
  static void setUser(String userId) {
    if (LOG.isLoggable(Level.FINEST)) {
      LOG.entering(EJB2SecurityOwner.class.getName(), "setUser", userId);
    }
    Misc.checkArgsNotNull(userId, "User can't be null!");
    USERS.set(userId);
    if (LOG.isLoggable(Level.FINE)) {
      LOG.fine("User set: " + userId);
    }
    if (LOG.isLoggable(Level.FINEST)) {
      LOG.exiting(EJB2SecurityOwner.class.getName(), "setUser");
    }
  }
  
  

}
